using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using NiiPrinterCLib;

namespace VCS_ClsSample
{
    public partial class Form1 : Form
    {
        NIIClassLib nii;

        public Form1()
        {
            InitializeComponent();
            nii = new NIIClassLib();
        }

        //NiiStartDoc
        private void Command4_Click(object sender, EventArgs e)
        {
            int ret;
            long jid = 0;

            ret = nii.NiiStartDoc(Text8.Text, out jid);
            if (ret < 0)
                MessageBox.Show("Error");
            Text5.Text = Convert.ToString(jid);
        }

        //NiiEndDoc
        private void Command5_Click(object sender, EventArgs e)
        {
            int ret;

            ret = nii.NiiEndDoc(Text8.Text);
            if (ret < 0)
                MessageBox.Show("Error");
        }

        //NiiPrint
        private void Command1_Click(object sender, EventArgs e)
        {
            int ret;
            long jid = 0;

            ret = nii.NiiPrint(Text8.Text, Text1.Text, (long)Text1.Text.Length, out jid);
            if (ret < 0)
                MessageBox.Show("Error");
            Text5.Text = Convert.ToString(jid);
        }

        //NiiImagePrint
        private void Command2_Click(object sender, EventArgs e)
        {
            int ret;
            long jid = 0;
            IntPtr hdc;
            string wk;

            //foCXReLXg(HDC)擾
            Graphics g = Picture1.CreateGraphics();
            g.DrawImage(Picture1.Image, 0, 0, Picture1.Image.Width, Picture1.Image.Height);
            hdc = g.GetHdc();

            //C[Wo(FILE)
            ret = nii.NiiImagePrint(Text8.Text, hdc, Picture1.Image.Width, Picture1.Image.Height, true, out jid);
            if (ret < 0)
                MessageBox.Show("Error");
            Text5.Text = Convert.ToString(jid);

            //C[Wo(LINE)
            ret = nii.NiiImagePrint(Text8.Text, hdc, Picture1.Image.Width, Picture1.Image.Height, false, out jid);
            if (ret < 0)
                MessageBox.Show("Error");
            Text5.Text = Convert.ToString(jid);

            //C[Wo(BIT)
            ret = nii.NiiBitImagePrint(Text8.Text, hdc, Picture1.Image.Width, Picture1.Image.Height, out jid);
            if (ret < 0)
                MessageBox.Show("Error");
            Text5.Text = Convert.ToString(jid);

            wk = "1B4A781b69";
            ret = nii.NiiPrint(Text8.Text, wk, (long)wk.Length, out jid);
            //\[XJ
            g.ReleaseHdc(hdc);
            g.Dispose();
        }

        //NiiGetStatus
        private void Command3_Click(object sender, EventArgs e)
        {
            long st = 0;
            int ret;

            ret = nii.NiiGetStatus(Text8.Text, out st);
            if (ret < 0)
                MessageBox.Show("Error");
            Text2.Text = Convert.ToString(st);
        }

        //NiiGetInfomation<Model ID=2>
        private void Command6_Click(object sender, EventArgs e)
        {
            int ret;
            long tm = 0;
            byte[] dat = new byte[64];

            ret = nii.NiiGetInformation(Text8.Text, (byte)2, dat, out tm);
            if (ret < 0)
                MessageBox.Show("Error");

            //Model&Time
            Text3.Text = "";
            for (int i = 0; i < 64; i++)
                Text3.Text += (char)dat[i];
            Text4.Text = Convert.ToString(tm);
        }

        //NiiGetInfomation<EndDoc ID=19>
        private void Command9_Click(object sender, EventArgs e)
        {
            int ret;
            long tm = 0;
            byte[] dat = new byte[64];

            ret = nii.NiiGetInformation(Text8.Text, (byte)19, dat, out tm);
            if (ret < 0)
                MessageBox.Show("Error");

            Text9.Text = "";
            Text7.Text = "";
            Text9.Text = Convert.ToString(BitConverter.ToUInt32(dat, 0));
            for (int i = 4; i < 8; i++)
                Text7.Text += dat[i].ToString("X2");
            Text6.Text = Convert.ToString(tm);
        }

        //PrintSample
        private void Command7_Click(object sender, EventArgs e)
        {
            int ret;
            int cmd;
            long jid = 0;
            long sjid = 0;
            string wk;
            IntPtr hdc;

            //foCXReLXg(HDC)擾
            Graphics g = Picture1.CreateGraphics();
            g.DrawImage(Picture1.Image, 0, 0, Picture1.Image.Width, Picture1.Image.Height);
            hdc = g.GetHdc();

            ret = nii.NiiStartDoc(Text8.Text, out jid);
            if (ret < 0)
                MessageBox.Show("Error");
                Text5.Text = Convert.ToString(jid);

            //󎚊Jn錾
            cmd = int.Parse(Text5.Text);
            wk = "1D\"G\"11" + cmd.ToString("X2") + "000000";
            ret = nii.NiiPrint(Text8.Text, wk, (long)wk.Length, out sjid);
            if (ret < 0)
                MessageBox.Show("Error");
            //󎚑O
            wk = "1B\"@\"1B4AFF1D7E801B6101";
            ret = nii.NiiPrint(Text8.Text, wk, (long)wk.Length, out sjid);
            if (ret < 0)
                MessageBox.Show("Error");
            //hLgC[Wo
            wk = "\"TEST Image START\"0a";
            ret = nii.NiiPrint(Text8.Text, wk, (long)wk.Length, out sjid);
            if (ret < 0)
                MessageBox.Show("Error");
            ret = nii.NiiImagePrint(Text8.Text, hdc, Picture1.Image.Width, Picture1.Image.Height, true, out jid);
            if (ret < 0)
                MessageBox.Show("Error");
            wk = "1B\"@TEST Image END\"0a";
            ret = nii.NiiPrint(Text8.Text, wk, (long)wk.Length, out sjid);
            if (ret < 0)
                MessageBox.Show("Error");
            //󎚌㏈
            wk = "1B4A781b69";
            ret = nii.NiiPrint(Text8.Text, wk, (long)wk.Length, out sjid);
            if (ret < 0)
                MessageBox.Show("Error");
            wk = "1D\"G\"10";
            ret = nii.NiiPrint(Text8.Text, wk, (long)wk.Length, out sjid);
            if (ret < 0)
                MessageBox.Show("Error");
            ret = nii.NiiEndDoc(Text8.Text);
            if (ret < 0)
                MessageBox.Show("Error");

            //\[XJ
            g.ReleaseHdc(hdc);
            g.Dispose();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            long st = 0;
            int ret;
            long tm = 0;
            byte[] dat = new byte[64];

            ret = nii.NiiGetStatus(Text8.Text, out st);
            if (ret < 0)
                Text2.Text = "Error" + Convert.ToString(ret);
            else
                Text2.Text = Convert.ToString(st);
            ret = nii.NiiGetInformation(Text8.Text, (byte)19, dat, out tm);
            if (ret < 0)
                Text9.Text = "Error" + Convert.ToString(ret);

            Text9.Text = "";
            Text7.Text = "";
            Text9.Text = Convert.ToString(BitConverter.ToUInt32(dat, 0));
            for (int i = 4; i < 8; i++)
                Text7.Text += dat[i].ToString("X2");
            Text6.Text = Convert.ToString(tm);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            long tm=0;
            long st = 0;
            byte[] dat = new byte[4];

            nii.PrinterName = Text8.Text;
            dat = BitConverter.GetBytes(nii.NiiGetJobEndInf(out st, out tm));
            textBox4.Text = Convert.ToString(BitConverter.ToUInt32(dat,0));
            textBox5.Text = Convert.ToString(st, 16);
            textBox6.Text = Convert.ToString(tm);
        }
    }
}