#include <stdio.h>

//Function address 
typedef int (WINAPI *lpNiiPrint)(PCHAR,PCHAR,DWORD,PDWORD);
typedef int (WINAPI *lpNiiImagePrintEx)(PCHAR,HDC, int,int,BYTE,PDWORD);
typedef int (WINAPI *lpNiiBitImagePrint)(PCHAR,HDC, int,int,PDWORD);
typedef int (WINAPI *lpNiiGetStatus)(PCHAR,LPDWORD);
typedef int (WINAPI *lpNiiStartDoc)(PCHAR,PDWORD);
typedef int (WINAPI *lpNiiEndDoc)(PCHAR);
typedef int (WINAPI *lpNiiCancelDoc)(PCHAR);
typedef int (WINAPI *lpNiiGetInformation)(PCHAR,BYTE,PVOID,PDWORD);

typedef int (WINAPI *lpNiiDPrint)(PCHAR,PBYTE,DWORD,PDWORD);
typedef int (WINAPI *lpNiiBarcode)(PCHAR,PCHAR,HDC,int,int,int,int,PBYTE,DWORD);

typedef int (WINAPI *lpNiiImagePrintF)(PCHAR,PCHAR,BYTE,PDWORD);
typedef int (WINAPI *lpNiiBitImagePrintF)(PCHAR,PCHAR,PDWORD);
typedef int (WINAPI *lpNiiResetPrinter)(PCHAR);

class CPrinterAPI 
{
protected:
	// Handle to a DLL
    HINSTANCE hLibHandle;

private:
    lpNiiPrint m_NiiPrint;
    lpNiiImagePrintEx m_NiiImagePrintEx;
    lpNiiBitImagePrint m_NiiBitImagePrint;
    lpNiiGetStatus m_NiiGetStatus;
    lpNiiStartDoc m_NiiStartDoc;
    lpNiiEndDoc m_NiiEndDoc;
    lpNiiCancelDoc m_NiiCancelDoc;
    lpNiiGetInformation m_NiiGetInformation;
    lpNiiDPrint m_NiiDPrint;
    lpNiiBarcode m_NiiBarcode;
    lpNiiImagePrintF m_NiiImagePrintF;
    lpNiiBitImagePrintF m_NiiBitImagePrintF;
    lpNiiResetPrinter m_NiiResetPrinter;

public:
	// Constructor
	CPrinterAPI(void)
	{
		hLibHandle = NULL;
		m_NiiPrint          = NULL;
		m_NiiImagePrintEx   = NULL;
		m_NiiBitImagePrint  = NULL;
		m_NiiGetStatus      = NULL;
		m_NiiStartDoc       = NULL;
		m_NiiEndDoc         = NULL;
		m_NiiCancelDoc      = NULL;
		m_NiiGetInformation = NULL;
		m_NiiDPrint         = NULL;
		m_NiiBarcode        = NULL;
		m_NiiImagePrintF    = NULL;
		m_NiiBitImagePrintF = NULL;
		m_NiiResetPrinter   = NULL;
	};
	//Destructor
	virtual ~CPrinterAPI()
	{
		if ( hLibHandle != NULL ) 
		{
			::FreeLibrary(hLibHandle);
		}
	};

	// Public API Functions. Must call Initialize() before anything else
	BOOL Initialize()
	{
		hLibHandle = ::LoadLibrary("NiiPrinterLib.DLL");
		if ( hLibHandle != NULL ) 
		{
			m_NiiPrint = (lpNiiPrint)GetProcAddress(hLibHandle,"NiiPrint");
			m_NiiImagePrintEx = (lpNiiImagePrintEx)GetProcAddress(hLibHandle,"NiiImagePrintEx");
			m_NiiBitImagePrint = (lpNiiBitImagePrint)GetProcAddress(hLibHandle,"NiiBitImagePrint");
			m_NiiGetStatus = (lpNiiGetStatus)GetProcAddress(hLibHandle,"NiiGetStatus");
			m_NiiStartDoc = (lpNiiStartDoc)GetProcAddress(hLibHandle,"NiiStartDoc");
			m_NiiEndDoc = (lpNiiEndDoc)GetProcAddress(hLibHandle,"NiiEndDoc");
			m_NiiCancelDoc = (lpNiiCancelDoc)GetProcAddress(hLibHandle,"NiiCancelDoc");
			m_NiiGetInformation = (lpNiiGetInformation)GetProcAddress(hLibHandle,"NiiGetInformation");
			m_NiiDPrint = (lpNiiDPrint)GetProcAddress(hLibHandle,"NiiDPrint");
			m_NiiBarcode = (lpNiiBarcode)GetProcAddress(hLibHandle,"NiiBarcode");
			m_NiiImagePrintF = (lpNiiImagePrintF)GetProcAddress(hLibHandle,"NiiImagePrintF");
			m_NiiBitImagePrintF = (lpNiiBitImagePrintF)GetProcAddress(hLibHandle,"NiiBitImagePrintF");
			m_NiiResetPrinter = (lpNiiResetPrinter)GetProcAddress(hLibHandle,"NiiResetPrinter");

			if (m_NiiPrint != NULL &&
				m_NiiImagePrintEx != NULL &&
				m_NiiBitImagePrint != NULL &&
				m_NiiGetStatus != NULL &&
				m_NiiStartDoc != NULL &&
				m_NiiEndDoc != NULL &&
				m_NiiCancelDoc != NULL &&
				m_NiiGetInformation != NULL &&
				m_NiiDPrint != NULL &&
				m_NiiBarcode != NULL &&
				m_NiiImagePrintF != NULL &&
				m_NiiBitImagePrintF != NULL &&
				m_NiiResetPrinter != NULL)
				return TRUE;
			else	 
				return FALSE;
		}
		else 
			return FALSE;
	};
	int NiiPrint(PCHAR i_prt, PCHAR i_dat, DWORD i_size, PDWORD o_jobid)
	{
		if (m_NiiPrint!=NULL ) 
			return m_NiiPrint(i_prt, i_dat, i_size, o_jobid);
		return -9999;
	};
	int NiiImagePrintEx(PCHAR i_prt, HDC i_bmp, int i_x, int i_y, BYTE i_file, PDWORD o_jobid)
	{
		if (m_NiiImagePrintEx!=NULL ) 
			return m_NiiImagePrintEx(i_prt, i_bmp, i_x, i_y, i_file, o_jobid);
		return -9999;
	};
	int NiiBitImagePrint(PCHAR i_prt, HDC i_bmp, int i_x, int i_y, PDWORD o_jobid)
	{
		if (m_NiiBitImagePrint!=NULL ) 
			return m_NiiBitImagePrint( i_prt,  i_bmp,  i_x,  i_y,  o_jobid);
		return -9999;
	};
	int NiiGetStatus(PCHAR i_prt, LPDWORD o_status)
	{
		if (m_NiiGetStatus!=NULL ) 
			return m_NiiGetStatus( i_prt,  o_status);
		return -9999;
	};
	int NiiStartDoc(PCHAR i_prt, PDWORD o_jobid)
	{
		if (m_NiiStartDoc!=NULL ) 
			return m_NiiStartDoc( i_prt,  o_jobid);
		return -9999;
	};
	int NiiEndDoc(PCHAR i_prt)
	{
		if (m_NiiEndDoc!=NULL ) 
			return m_NiiEndDoc( i_prt);
		return -9999;
	};
	int NiiCancelDoc(PCHAR i_prt)
	{
		if (m_NiiCancelDoc!=NULL ) 
			return m_NiiCancelDoc( i_prt);
		return -9999;
	};
	int NiiGetInformation(PCHAR i_prt, BYTE i_id, PVOID o_dat, PDWORD o_time)
	{
		if (m_NiiGetInformation!=NULL ) 
			return m_NiiGetInformation( i_prt,  i_id,  o_dat,  o_time);
		return -9999;
	};
	int NiiDPrint(PCHAR i_prt, PBYTE i_dat, DWORD i_size, PDWORD o_jobid)
	{
		if (m_NiiDPrint!=NULL ) 
			return m_NiiDPrint( i_prt,  i_dat,  i_size,  o_jobid);
		return -9999;
	};
	int NiiBarcode(PCHAR i_prt,PCHAR i_fname, HDC i_bmp, int i_x, int i_y, int i_width, int i_height,PBYTE i_dat,DWORD i_size)
	{
		if (m_NiiBarcode!=NULL ) 
			return m_NiiBarcode( i_prt, i_fname,  i_bmp,  i_x,  i_y, i_width, i_height, i_dat, i_size);
		return -9999;
	};
	int NiiImagePrintF(PCHAR i_prt, PCHAR i_bmp, BYTE i_file, PDWORD o_jobid)
	{
		if (m_NiiImagePrintEx!=NULL ) 
			return m_NiiImagePrintF(i_prt, i_bmp, i_file, o_jobid);
		return -9999;
	};
	int NiiBitImagePrintF(PCHAR i_prt, PCHAR i_bmp, PDWORD o_jobid)
	{
		if (m_NiiBitImagePrint!=NULL ) 
			return m_NiiBitImagePrintF( i_prt,  i_bmp,  o_jobid);
		return -9999;
	};
	int NiiResetPrinter(PCHAR i_prt)
	{
		if (m_NiiResetPrinter!=NULL ) 
			return m_NiiResetPrinter( i_prt);
		return -9999;
	};

};